LeetCode300:最长递增子序列

题目链接:300. 最长递增子序列 - 力扣(LeetCode)

代码如下

复制代码
class Solution {
public:
    int lengthOfLIS(vector<int>& nums) {
        //dp[i]是nums[i]的最大递增子序列
        //dp[i] = max(dp[j] + 1, dp[i]);
        int len = nums.size();
        if(len <= 1)    return len;
        vector<int> dp(len + 1, 1);
        int result = 0;
        dp[0] = 1;
        for(int i = 1; i < len; i++)
        {
            for(int j = 0; j < i; j++)
            {
                if(nums[i] > nums[j])
                {
                    dp[i] = max(dp[j] + 1, dp[i]);
                }
            }
            if(dp[i] > result)
            {
                result = dp[i];
            }
        }

        return result;

    }
};

这个题目其实就是去寻找一个子序列在原有的序列中找到一个递增的就好

确定dp含义:dpi其实也就是题目所说的我们需要去寻找一个递增的子序列,那我们就定义dpi为numsi的最大递增子序列

dp递推公式:这个就是我们画一个数轴,如果我们要去找到一个最大的,那我们定好0到i这个区间,然后再用一个j来遍历,条件就是numsi>numsj,然后去推导出来公式dpi = max(dpj + 1, dpi),dpj + 1是因为我们如果想让dpj和dpi相等,那么我们只能dpj + 1来等于dpi,dpi的意思是,就是我们与dpi作比较,然后取一个最大值

初始化:dp0 = 1, 因为就一个数嘛,那么就只有一种

遍历顺序:两层for循环,第一层for是为了定义0 - i的区间,第二层for循环是在0 - i的区间里,再去用一个j去找到一个最大值

返回的参数:在定义一个result = 0,找到的dpi的值,去与result比较,这个时候千万不是dpnums.size() - 1,因为很有可能最后一个并不是这个递增子序列的最后一个

相关推荐
lvwangshu5 小时前
CF1882D Tree XOR 题解
动态规划·题解·贪心·dp·树形dp·换根dp·性质题·思维好题·推导题
罗湖老棍子5 小时前
【例 1】Sightseeing Trip(信息学奥赛一本通- P1494)(洛谷-P10927)
数据结构·算法·图论·最短路·floyd·最小环
文丑颜不良啊6 小时前
LeetCode201~225题目解析
java·leetcode
stsdddd8 小时前
YOLO算法建筑工地安全帽目标检测数据集16881张:标注核对笔记
算法·yolo·目标检测
CV爱数码8 小时前
论文精读|Learned Primal-Dual:把原始–对偶算法展开成网络
图像处理·算法·计算机视觉·ct·重建·断层扫描
yuniko-n9 小时前
【算法】约瑟夫环问题
java·算法
Interview Aid1129 小时前
Snowflake OA 面试真题:前缀和、BFS 与动态规划
面试·动态规划·宽度优先
l1t9 小时前
测试DuckDB v2.1.0-alpha49002的bignum乘法
数据库·sql·算法·duckdb
Nil2089 小时前
LeetCode 283移动零
数据结构·算法·leetcode
CQU_JIAKE9 小时前
10.18【A】
算法